/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.tables.records.VCoreMissinglistRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VCoreMissinglist extends TableImpl<VCoreMissinglistRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_core_missinglist</code>
     */
    public static final VCoreMissinglist V_CORE_MISSINGLIST = new VCoreMissinglist();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VCoreMissinglistRecord> getRecordType() {
        return VCoreMissinglistRecord.class;
    }

    /**
     * The column <code>common_dd.v_core_missinglist.key_variable</code>.
     */
    public final TableField<VCoreMissinglistRecord, Integer> KEY_VARIABLE = createField(DSL.name("key_variable"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_core_missinglist.num_missings</code>.
     */
    public final TableField<VCoreMissinglistRecord, String> NUM_MISSINGS = createField(DSL.name("num_missings"), SQLDataType.CLOB, this, "");

    private VCoreMissinglist(Name alias, Table<VCoreMissinglistRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VCoreMissinglist(Name alias, Table<VCoreMissinglistRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_core_missinglist" as  SELECT t_core_variable.key_variable,
          string_agg((''::text || t_dm_missingcode.num_missingcode), ','::text) AS num_missings
         FROM (((common_dd.t_core_variable
           LEFT JOIN common_dd.t_core_missingvalue ON ((t_core_missingvalue.fk_missinglist = t_core_variable.fk_missinglist)))
           LEFT JOIN common_dd.t_dm_missingvalue ON ((t_dm_missingvalue.fk_core_missingvalue = t_core_missingvalue.pk)))
           LEFT JOIN common_dd.t_dm_missingcode ON ((t_dm_missingcode.pk = t_dm_missingvalue.fk_missingcode)))
        WHERE (t_core_variable.fk_missinglist IS NOT NULL)
        GROUP BY t_core_variable.key_variable;
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_core_missinglist</code> table
     * reference
     */
    public VCoreMissinglist(String alias) {
        this(DSL.name(alias), V_CORE_MISSINGLIST);
    }

    /**
     * Create an aliased <code>common_dd.v_core_missinglist</code> table
     * reference
     */
    public VCoreMissinglist(Name alias) {
        this(alias, V_CORE_MISSINGLIST);
    }

    /**
     * Create a <code>common_dd.v_core_missinglist</code> table reference
     */
    public VCoreMissinglist() {
        this(DSL.name("v_core_missinglist"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VCoreMissinglist as(String alias) {
        return new VCoreMissinglist(DSL.name(alias), this);
    }

    @Override
    public VCoreMissinglist as(Name alias) {
        return new VCoreMissinglist(alias, this);
    }

    @Override
    public VCoreMissinglist as(Table<?> alias) {
        return new VCoreMissinglist(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreMissinglist rename(String name) {
        return new VCoreMissinglist(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreMissinglist rename(Name name) {
        return new VCoreMissinglist(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreMissinglist rename(Table<?> name) {
        return new VCoreMissinglist(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreMissinglist where(Condition condition) {
        return new VCoreMissinglist(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreMissinglist where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreMissinglist where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreMissinglist where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreMissinglist where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreMissinglist where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreMissinglist where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreMissinglist where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreMissinglist whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreMissinglist whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
